"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@tiptap/react");
var HtmlEditorFloatEditToolbar = function (props) {
    var editor = props.editor, hideH1 = props.hideH1, hideH2 = props.hideH2, hideH3 = props.hideH3, hideH4 = props.hideH4, supportSourceCode = props.supportSourceCode;
    var onChangeHeader = function (level) {
        editor.chain().focus().toggleHeading({ level: level }).run();
    };
    var onClickLink = function () {
        var hasLink = editor.isActive('link');
        if (hasLink) {
            editor.chain().focus().toggleLink().run();
        }
        else {
            var url = window.prompt('URL', editor.getAttributes('link').href);
            if (!(0, primeobjects_helper_util_1.isNonEmptyString)(url))
                return;
            editor
                .chain()
                .focus()
                .extendMarkRange('link')
                .setLink({ href: url })
                .run();
        }
    };
    return react_1.default.createElement(react_2.BubbleMenu, { editor: editor, className: "menu-wrapper" },
        react_1.default.createElement("div", { className: "menu" },
            !hideH1 && react_1.default.createElement("div", { onClick: function () { return onChangeHeader(1); }, className: "menu-text ".concat(editor.isActive('heading', { level: 1 }) ? 'active' : '') }, "H1"),
            !hideH2 && react_1.default.createElement("div", { onClick: function () { return onChangeHeader(2); }, className: "menu-text ".concat(editor.isActive('heading', { level: 2 }) ? 'active' : '') }, "H2"),
            !hideH3 && react_1.default.createElement("div", { onClick: function () { return onChangeHeader(3); }, className: "menu-text ".concat(editor.isActive('heading', { level: 3 }) ? 'active' : '') }, "H3"),
            !hideH4 && react_1.default.createElement("div", { onClick: function () { return onChangeHeader(4); }, className: "menu-text ".concat(editor.isActive('heading', { level: 4 }) ? 'active' : '') }, "H4"),
            react_1.default.createElement("div", { className: "menu-sp" }),
            react_1.default.createElement("div", { onClick: function () { return editor.chain().focus().toggleBold().run(); }, className: "menu-text menu-text-bold ".concat(editor.isActive('bold') ? 'active' : '') }, "B"),
            react_1.default.createElement("div", { onClick: function () { return editor.chain().focus().toggleItalic().run(); }, className: "menu-text menu-text-italic ".concat(editor.isActive('italic') ? 'active' : '') }, "I"),
            react_1.default.createElement("div", { onClick: function () { return editor.chain().focus().toggleStrike().run(); }, className: "menu-text menu-text-strikethrough ".concat(editor.isActive('strike') ? 'active' : '') }, "T"),
            react_1.default.createElement("div", { className: "menu-sp" }),
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/material-bullet-list.svg", onClick: function () { return editor.chain().focus().toggleBulletList().run(); }, className: "menu-icon ".concat(editor.isActive('bulletList') ? 'active' : '') }),
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/material-numbered-list.svg", onClick: function () { return editor.chain().focus().toggleOrderedList().run(); }, className: "menu-icon ".concat(editor.isActive('orderedList') ? 'active' : '') }),
            react_1.default.createElement("div", { className: "menu-sp" }),
            supportSourceCode && react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/source-code.svg", onClick: function () { return editor.chain().focus().toggleCodeBlock().run(); }, className: "menu-icon ".concat(editor.isActive('codeBlock') ? 'active' : '') }),
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/material-get-quote.svg", onClick: function () { return editor.chain().focus().toggleBlockquote().run(); }, className: "menu-icon ".concat(editor.isActive('blockquote') ? 'active' : '') }),
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/material-link.svg", onClick: onClickLink, className: "menu-icon ".concat(editor.isActive('link') ? 'active' : '') })));
};
exports.default = HtmlEditorFloatEditToolbar;
